cam - Fix bus registration race
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 BINUTILS 2.27 REPLACES 2.24, PRIMARY
16 ------------------------------------
17
18 The oldest of the two versions of Binutils, version 2.24, was removed
19 and replaced with Binutils 2.27.  It becomes the primary version version
20 of binutils and version 2.25 becomes the alternate.
21
22 The accepted values of BINUTILSVER are now "binutils227" (default) and
23 "binutils225".  The building of Binutils 2.25 can be prevented by setting
24 NO_ALTBINUTILS=yes in make.conf.
25
26 COMPAT_43 KERNEL OPTION REMOVED
27 -------------------------------
28
29 It was commented out in our default configs for several years now, but
30 might still be present in custom configs created before Nov. 2011.
31
32 OPENSSL REMOVED
33 ---------------
34
35 OpenSSL has been removed from base and replaced with a private version of
36 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
37 pages will remain on the system unless the "make upgrade" command is
38 specifically instructed to remove them.  To do this, define
39 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
40 "make upgrade REMOVE_OPENSSL_FILES=yes"
41
42 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
43 stale OpenSSL files be removed to avoid configuration scripts from using
44 the stale and potentially vulnerable version, but all binaries that are
45 dynamically linked to the OpenSSL libraries should be rebuilt first to
46 avoid breakage.
47
48 CS, EX AND VX DRIVERS REMOVED
49 -----------------------------
50
51 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
52 old and its doubtful they ever worked properly in x86_64 but they were
53 in X86_64_GENERIC, so custom configurations derived from it have to be
54 adjusted.
55
56 +-----------------------------------------------------------------------+
57 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
58 +-----------------------------------------------------------------------+
59
60 AMD REMOVED
61 -----------
62
63 The am-utils automounter suite has been removed. It stopped working
64 at some point and was never fixed. autofs(5) and the associated
65 userland has been brought in from FreeBSD and replaces it.
66
67 AN DRIVER REMOVED
68 -----------------
69
70 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
71 config file, so any configurations derived from it have to be adjusted.
72
73 /DEV/DRI GROUP CHANGED
74 ----------------------
75
76 The default group assigned to /dev/dri entries has been changed
77 from 'wheel' to 'video' with the id of '44'. If you want to have
78 access to the dri devices please add yourself to the video group
79 with:
80
81 # pw groupmod video -m $USER
82
83 +-----------------------------------------------------------------------+
84 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
85 +-----------------------------------------------------------------------+
86
87 DSCHED REMOVED
88 --------------
89
90 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
91 in our default kernel config file. So the DSCHED_FQ option has been turned
92 into a no-op for now and can be removed from custom configurations.
93
94 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
95 -------------------------------------------------
96
97 The est(4) driver has been removed. All CPUs it supported (except one)
98 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
99 report back if there are any issues with this CPU and our regular ACPI
100 P-state support.
101
102 Also, compile_et(1) and com_err(3) have been removed as well. They
103 should have been removed along with kerberos support, back in 2009.
104
105 SEVERAL LOCALES RENAMED
106 -----------------------
107
108 Several locales were using obsolete and misleading names, and thus have
109 been adjusted to current standards. Any users of the following locales
110 need to select alternates:
111
112 DFLY 4.2 locale            DFLY 4.4 alterative locale
113 ---------------            ------------------------------------
114 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
115 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
116 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
117 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
118 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
119 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
120 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
121 zh_CN.GBK                  zh_Hans_CN.GBK
122 zh_CN.UTF-8                zh_Hans_CN.UTF-8
123 zh_CN.eucCN                zh_Hans_CN.eucCN
124 zh_CN.GB2312               zh_Hans_CH.GB2312
125 zh_CN.GB18030              zh_Hans_CH.GB18030
126 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
127 zh_HK.UTF_8                zh_Hant_HK.UTF-8
128 zh_TW.Big5                 zh_Hant_TW.Big5
129 zh_TW.UTF-8                zh_Hant_TW.UTF-8
130
131 +-----------------------------------------------------------------------+
132 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
133 +-----------------------------------------------------------------------+
134
135 BINUTILS 2.25 REPLACES 2.22, PRIMARY
136 ------------------------------------
137
138 The oldest of the two versions of Binutils, version 2.22, was removed
139 and replaced with Binutils 2.25.  It becomes the primary version version
140 of binutils and version 2.24 becomes the alternate.  There are 8 current
141 CVE written against 2.24, so for security reasons version 2.25 should
142 always be used.
143
144 The accepted values of BINUTILSVER are now "binutils225" (default) and
145 "binutils224".  The building of Binutils 2.24 can be prevented by setting
146 NO_ALTBINUTILS=yes in make.conf.
147
148 LOADER OPTIONS CHANGED
149 ----------------------
150
151 Right after the development branch started, the Fred art accompanying the
152 loader menu was improved.  The line between Fred and the menu was removed
153 by default (but can optionally be returned) and the placement shifted as
154 a result.  The drawing was improved, and the colored version was improved,
155 changing the eyes and wing color from white to red.  A new color version
156 of Fred was added, one with a blue scheme.
157
158 The loader menu defaults have changed since release 4.0:  The vertical
159 line was removed, the loader is displayed in color by default*, and the
160 blue scheme is used.
161
162 The loader.conf changes are:
163 loader_color:   option has been removed
164 loader_plain:   option has been added, it changed menu to monochrome
165 fred_is_red:    changes color scheme from blue to red
166 fred_is_blue:   option existed only on 4.1, it has been removed
167 fred_separated: Adds line between Fred and menu (as seen previously)
168
169 * If loader.conf defines "console" as "comconsole" or "console" is defined
170   in the environment as "comconsole" then color will not be displayed,
171   even if loader_plain value is "NO".
172
173 SENDMAIL REMOVED FROM BASE
174 --------------------------
175
176 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
177 If the system being upgraded is still configured to use the sendmail
178 binaries from base, the "make upgrade" command will fail.
179
180 The administrator must change /etc/mail/mailer.conf to switch the
181 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
182 command that permanently removes sendmail executables and could
183 potentially break a running mail server.
184
185 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
186 detailed instructions on how to configure the MTA selection.
187
188 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
189 --------------------------------------------
190
191 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
192 no-ops. They can be removed from custom kernel configurations.
193
194 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
195 --------------------------------------------
196
197 Many more sound devices may be detected.
198
199 If the default device choosen isn't to your liking, setting the sysctl
200 hw.snd.default_unit to a different number will change it.
201
202 SCTP SUPPORT DROPPED
203 --------------------
204
205 Support for the SCTP protocol has been removed.
206
207 OLD USB DRIVERS REMOVED
208 -----------------------
209
210 The old USB stack, along with the kernel config option "device oldusb"
211 and the make.conf variable "WANT_OLDUSB" have been removed. This means
212 that for custom kernel configuration files which were derived from a
213 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
214 various (old USB stack specific) devices will now complain about being
215 unknown:
216
217   * oldusb      (obviously)
218   * natausb     (not yet ported to usb4bsd)
219   * rue         (not yet ported to usb4bsd)
220   * ugen        (no longer needed in usb4bsd)
221   * urio        (not yet ported to usb4bsd)
222   * uscanner    (no longer needed in usb4bsd)
223
224 They should be removed or commented out in such custom kernel configs.
225
226 GCC 5
227 -----
228
229 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
230 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
231 NO_CXX.  The latter was never documented and the latest versions of GCC are
232 partially written in C++ so a C++ compiler is no longer optional.  In
233 practical terms it has not been optional for many years as other base
234 components are also written in C++.  The resource savings by avoiding
235 building Objective-C compiler is so small, the complexity added by NO_OBJC
236 internally was deemed a bad tradeoff so that is the reason for its removal.
237 Also note that no "info" pages are installed with GCC 5.  After this entry
238 was originally written, all info pages were removed from DragonFly.
239
240 GCC 5.1 has been designated as the primary compiler.  As such, there is a
241 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
242 the designated secondary compiler, GCC 4.7.  However, while DPorts
243 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
244 if building ports from source is desired, don't block building of the
245 secondary compiler.
246
247 +-----------------------------------------------------------------------+
248 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
249 +-----------------------------------------------------------------------+
250
251 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
252 -------------------------------------------
253
254 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
255 the default now (even on single-core systems), both for, like, 21 months.
256 We kept the options around as no-ops as a convenience, to allow people
257 using the same config for the then current release and the then current
258 master. That period is now over, so any configs still having those
259 options have to be adjusted.
260
261 SYSVIPC SYSCALLS MADE NON-OPTIONAL
262 ----------------------------------
263
264 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
265 now compiled in by default. The options are no-ops for now.
266
267 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
268 --------------------------------------------------------------------
269
270 The default driver for those controllers is now mrsas(4) due to reports
271 of file system corruption using the mfi(4) driver. The whole issue (and
272 how to deal with potential problems when switching) was explained here:
273
274 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
275
276 A tunable is provided for letting those controllers still attach via
277 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
278
279 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
280 ----------------------------------------
281
282 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
283 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
284 removed in kernel configs derived from X86_64_GENERIC.
285
286 +-----------------------------------------------------------------------+
287 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
288 +-----------------------------------------------------------------------+
289
290 UPDATE FROM MOST RECENT 3.6
291 ---------------------------
292
293 Versions of 3.6 built before June 25th have a bug where installworld might 
294 crash during installation of the new initrd.  Upgrade to the latest version
295 of 3.6 before updating to 3.8 or later.
296
297 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
298 --------------------------------------
299
300 Support for the IPX and NCP network protocols and for mouting NetWare
301 file systems has been dropped. Dito for ATM protocol support.
302
303 INITRD IMAGES NOW INSTALLED BY DEFAULT
304 --------------------------------------
305
306 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
307
308 Older images installed under the file name of initrd.img will be removed
309 automatically by the make upgrade process.
310
311 USB4BSD IS NOW THE DEFAULT USB STACK
312 ------------------------------------
313
314 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
315 replace "device usb" with "device oldusb" in the kernel configuration.
316
317 MORE ISA SUPPORT DROPPED
318 ------------------------
319
320 ISA support has been dropped from the following drivers: adv(4), an(4),
321 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
322 si(4), sn(4), and stg(4).
323
324 +-----------------------------------------------------------------------+
325 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
326 +-----------------------------------------------------------------------+
327
328 ABI CHANGE
329 ----------
330
331 Installed third-party software (dports) will have to be rebuilt after upgrade,
332 or reinstalled from binary packages.
333
334 UPDATING FROM 3.4 TO 3.6
335 ------------------------
336
337 This only applies for this specific upgrade due to locale changes; it is 
338 not needed for upgrades after 3.6.  Please update in this order:
339
340 make buildworld
341 make buildkernel
342 make installworld
343 make installkernel
344 *reboot*
345 make upgrade
346
347 See this mailing list post for details:
348 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
349
350 CYRIX OPTIONS REMOVED
351 ---------------------
352
353 The following Cyrix related options have been removed: CPU_BTB_EN,
354 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
355 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
356 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
357
358 ISA SUPPORT REMOVED FROM RP(4)
359 ------------------------------
360
361 ISA support has been removed from the rp(4) driver. It is now PCI only.
362
363 +-----------------------------------------------------------------------+
364 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
365 +-----------------------------------------------------------------------+
366
367 COMPAT_SUNOS OPTION REMOVED
368 ---------------------------
369
370 The COMPAT_SUNOS option has been removed. It was meant to provide binary
371 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
372
373 ISA SOUND CARD SUPPORT REMOVED
374 ------------------------------
375
376 The following modules have been removed (all for ISA sound cards):
377 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
378
379 GCC 4.7
380 -------
381
382 DragonFly has switched base compilers.  GCC 4.7 is now the default
383 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
384 variable ceases to work now.
385
386 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
387 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
388 highly discouraged.  There are a few packages in pkgsrc that do not build
389 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
390 this time, it is recommended to keep both compilers on the base system.
391
392 SMP OPTION REMOVED
393 ------------------
394
395 The SMP kernel option has been made a no-op. All kernels now feature SMP
396 support. If you have 'options SMP' in your kernel config, you can as well
397 remove it.
398
399 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
400 ---------------------------------------------------------------------------
401
402 The DEVICE_POLLING kernel option has been made a no-op and it has been
403 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
404 kernel config, you need to change it to IFPOLL_ENABLE.
405
406 Also, the KTR_POLLING kernel option has been removed, so it must be
407 removed from kernel configs that have it.
408
409 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
410 ---------------------------------------------------
411
412 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
413 cards will no longer be detected.
414
415 The same has been done for Stallion multiport serial controllers. stli(4)
416 has been completely removed (along with the stlload(8) and stlstty(8)
417 utilities) and stl(4) was changed to support only PCI cards. Similarly,
418 ISA support was removed from cy(4) too. All these drivers are i386 only.
419
420 COMPAT_OLDISA OPTION GONE
421 -------------------------
422
423 The i386 specific COMPAT_OLDISA kernel option has been removed, since
424 nothing needs it anymore.
425
426 +-----------------------------------------------------------------------+
427 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
428 +-----------------------------------------------------------------------+
429
430 APIC_IO OPTION REMOVED
431 ----------------------
432
433 The APIC_IO kernel option is no longer accepted after having been without
434 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
435 If you have 'options APIC_IO' in your kernel config, you'll have to
436 remove it.
437
438 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
439 -----------------------------------------
440
441 The wdog framework is now compiled into our kernels by default, so the
442 options are no longer needed.
443
444 DOSCMD(1) REMOVED
445 -----------------
446
447 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
448 NO_X make.conf option was removed too.
449
450 GCC 4.7
451 -------
452
453 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
454 default compiler in base (default is still GCC 4.4).
455
456 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
457 NO_GCC47 in /etc/make.conf.
458
459 USB4BSD
460 -------
461
462 A new USB stack (from FreeBSD) has been brought in. The following
463 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
464 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
465 and uaudio.
466
467 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
468 be put in make.conf and device "usb4bsd" (quotes needed) has to
469 replace device usb in the kernel config. After that, a full
470 build/install/upgrade cycle is needed.
471
472 Note that this is experimental and incomplete, but we are interested
473 in hearing about issues with it, of course.
474
475 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
476 ---------------------------------------------
477
478 ISA adapter support was dropped from the aic(4) driver.
479
480 +-----------------------------------------------------------------------+
481 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
482 +-----------------------------------------------------------------------+
483
484 SEVERAL ISA DRIVERS REMOVED
485 ---------------------------
486
487 The following ISA only drivers have been removed along with a couple of
488 associated userland tools:
489
490 aha(4)
491 asc(4) & sasc(1)
492 ctx
493 dgb(4)
494 el(4)
495 gpib
496 gsc(4) & sgsc(1)
497 ie(4)
498 labpc(4)
499 le(4)
500 mse(4)
501 rc(4)
502 rdp(4)
503 spigot
504 tw(4) & xten(1) & xtend(8)
505 wl(4) & wlconfig(8)
506 wt(4)
507
508 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
509 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
510 file.
511
512 If buildkernel complains about any of these drivers, just remove them
513 from your kernel configuration.
514
515 BINUTILS 2.20
516 -------------
517 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
518 values of BINUTILSVERS are now binutils221 and binutils222 (default).
519
520 BUILDWORLD/-KERNEL PARALLELIZATION WORK
521 ---------------------------------------
522 Due to changes in the way we build with more than one make job, you
523 will have to update install(1) and mkdir(1) prior to buildworld if you
524 want to build with 'make -j':
525
526 cd /usr/src/usr.bin/xinstall; make; make install; make clean
527 cd /usr/src/bin/mkdir; make; make install; make clean
528
529 DMA(8) UPGRADE
530 --------------
531 dma(8) has been upgraded to v0.7 which no longer supports the
532 /etc/dma/virtusertable. Some of its functionality has been replaced
533 with the MASQUERADE keyword and the EMAIL environment variable (see
534 the dma(8) manual page).
535
536 +-----------------------------------------------------------------------+
537 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
538 +-----------------------------------------------------------------------+
539
540 GCC 4.4 & BINUTILS 2.21
541 -----------------------
542
543 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
544 been made DragonFly's default Binutils.
545
546 That means that any settings that set CCVER to 'gcc44' are not needed
547 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
548 GCC 4.1.
549
550 It also means that 'binutils221' as a value for BINUTILSVER has no
551 effect anymore. 2.17 has been removed and 'binutils220' is available
552 as an option.
553
554 The NO_GCC44 option has been removed and will not affect the build
555 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
556 building in a similar fashion.
557
558 Note that you must do a full buildworld/buildkernel for upgrading.
559
560 pkg_radd settings
561 -----------------
562
563 The config file for pkg_radd has moved from /etc/settings.conf to 
564 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
565 if this is needed.  This warning only applies if /etc/settings.conf 
566 exists.  pkg_radd will continue to work with defaults.
567
568 +-----------------------------------------------------------------------+
569 +         20100927                                                      +
570 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
571 +-----------------------------------------------------------------------+
572
573 OpenSSL
574 --------
575
576 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
577 This shouldn't break any 3rd-party software, but you'll need to recompile your
578 3rd-party software if you want it to link against the new version of OpenSSL.
579
580 Loader
581 -------
582
583 A new loader (dloader) has been added which better handles booting from
584 multiple kernel/module versions.
585
586 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
587
588         cd /usr/src
589         make buildworld
590         make installworld
591         make upgrade
592         make buildkernel KERNCONF=<KERNELNAME>
593         make installkernel KERNCONF=<KERNELNAME>
594
595 Note that you must installworld and run the 'upgrade' target before
596 installing the new kernel.
597
598 BIND
599 -----
600
601 BIND has been removed from the base system.  The ldns and drill tools have 
602 been added for basic functionality.  Use 'drill' where you would normally 
603 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
604 net/bind95, net/bind96, or net/bind97 as of this writing.
605
606 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
607 include BIND as a pkgsrc package.
608
609 +-----------------------------------------------------------------------+
610 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
611 +                               GENERAL                                 +
612 +-----------------------------------------------------------------------+
613
614 Instructions on how to obtain and maintain DragonFly source code using git
615 are in the development(7) manual page.
616
617 To upgrade a DragonFly system from sources you run the following sequence:
618
619         cd /usr/src
620         make buildworld
621         make buildkernel KERNCONF=<KERNELNAME>
622         make installkernel KERNCONF=<KERNELNAME>
623         make installworld
624
625 You will also want to run the 'upgrade' target to upgrade your /etc and the
626 rest of your system.  The upgrade target is aware of stale files created by
627 older DragonFly installations and should delete them automatically.
628
629         make upgrade
630
631 See the build(7) manual page for further information.
632
633 Once you've done a full build of the world and kernel you can do incremental
634 upgrades of either by using the 'quickworld' and 'quickkernel' targets
635 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
636 the quick targets, try updating your repo first, and then a full buildworld
637 and buildkernel as shown above, before asking for help.
638
639 +-----------------------------------------------------------------------+
640 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
641 +-----------------------------------------------------------------------+
642
643 In 2.1 kernel and modules has moved to boot directory.  For most cases
644 this is handled automatically by 'make upgrade'.  A few cases needs manual
645 intervention:
646
647  * When installing a kernel without first doing a make buildworld,
648    installworld and upgrade to the same DESTDIR as kernel:
649    make DESTDIR/boot directory and move kernel and modules into this boot
650    directory; also move kernel.old and modules.old.
651    Typical example is vkernel(7), use (no modules used):
652
653         cd /var/vkernel
654         mkdir boot
655         chflags noschg kernel
656         mv kernel kernel.old boot
657         chflags schg boot/kernel
658         
659  * When using a boot-only partition, /boot/loader.rc needs to be edited:
660    delete occurrences of '/boot/'.
661    These occurences can normally be deleted in any case, see loader(8).
662
663 +-----------------------------------------------------------------------+
664 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
665 +-----------------------------------------------------------------------+
666
667 In 1.9 major changes to the disk management infrastructure have taken
668 place.  make upgrade may not catch all of your disk devices in /dev,
669 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
670 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
671 and MAKEDEV no longer exists.
672
673 The biggest changes in 1.9 are:
674
675 (1) That whole-slice devices such as da0s1 no longer share the same device
676     id as partition c devices such as da0s1c.
677
678 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
679     with no snooping or reserved sectors.  Consequently you cannot run
680     disklabel on this device.  Instead you must run disklabel on a
681     whole-slice device.
682
683 (3) The 'compatibility' partitions now use slice 0 in the device name,
684     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
685     accessing the disklabel for the compatibility partitions must be
686     done via slice 0 (da0s0).
687
688 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
689     and CCD now run through the disk management layer and are assigned
690     real disk management devices.   VN and CCD in particular do not usually
691     use a MBR and disklabels must be accessed through the compatibility
692     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
693     don't name it 'ccd0s0' in the config file.
694
695 Generally speaking, you have to get used to running fdisk and disklabel on
696 the correctly specified device names.  A lot of the wiggle, such as running
697 disklabel on a partition, has been removed.
698
699 +-----------------------------------------------------------------------+
700 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
701 +-----------------------------------------------------------------------+
702
703 > Kerberos IV
704 -------------
705
706 Kerberos IV (eBones) was removed from the tree, please consider moving to
707 Kerberos 5 (Heimdal).
708
709 > Package Management System
710 ---------------------------
711
712 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
713 management system.  The necessary tools to build and maintain packages
714 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
715 directories are in your PATH variable.
716
717 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
718 the tarball from NetBSD:
719
720         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
721         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
722
723 This tree can then be kept up to date with cvs update:
724
725         cd /usr/pkgsrc; cvs up
726
727 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
728 build and install the pkgsrc bootstrap manually:
729
730         cd /usr/pkgsrc/bootstrap
731         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
732
733 +-----------------------------------------------------------------------+
734 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
735 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
736 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
737 +-----------------------------------------------------------------------+
738
739 The compatibility shims for the build environment have been removed, you
740 have to update to DragonFly 1.2 release branch first.
741
742 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
743 The existing configuration can be converted using /etc/pam.d/convert.sh.
744 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
745 the pam_skey.so module was retired, you have to remove it manually from
746 your configuration, when you convert it.
747
748 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
749 ---------------------
750
751 The following users may be missing from your password file.  Use vipw and
752 add any that are missing:
753
754 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
755 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
756
757 The following groups may be missing from your group file.  Use vi /etc/group
758 and add any that are missing:
759
760 smmsp:*:25:
761 authpf:*:63:
762 _pflogd:*:64:
763
764
765 > Upgrading to DragonFly from FreeBSD
766 ---------------------
767
768 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
769 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
770 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
771 make depend information, it starts from scratch, so no pre-cleaning of the
772 object hierarchy is necessary.
773
774         # get the CVS repository (it is placed in /home/dcvs, 500MB).
775         # Please use the -h option and a mirror site to pull the 
776         # initial repository, but feel free to use the main repository
777         # machine to pull updates.
778         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
779         # install the source from the CVS hierarchy (remove preexisting
780         # FreeBSD src first) (500MB)
781         cd /usr
782         rm -rf src
783         cvs -R -d /home/dcvs checkout -P src
784
785         # build it (500MB used in /usr/obj)
786         #
787         cd /usr/src
788         make buildworld
789         make buildkernel KERNCONF=<KERNELNAME>
790
791 Once you have built DragonFly you have to install it over FreeBSD.  Since
792 DragonFly does not track changes made by FreeBSD to its include file 
793 hierarchy and include file pollution can cause all sorts of unexpected
794 compilation issues to come up, it is best to wipe your include hierarchy
795 prior to installing DragonFly.  Note that you should not wipe any installed
796 FreeBSD header files or binaries until after you have successfully completed
797 the build steps above.
798
799         rm -rf /usr/include
800         mkdir /usr/include
801         make installkernel KERNCONF=<KERNELNAME>
802         make installworld
803
804 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
805 will unconditionally upgrade the /etc files that sysops do not usually
806 mess around with, such as the files in /etc/rc.d.  It will also remove any
807 obsolete files such as utilities and manpages that have been removed from
808 the system since the version you're coming from.  If you are unsure we 
809 recommend that you make a backup of at least your /etc before applying
810 this step.  Note that DragonFly's RC system is basically RCNG from
811 FreeBSD-5, but there are some differences in the contents of the RC files.
812
813         make upgrade
814
815 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
816 Doing so might leave your system in an unusable state.
817
818 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
819 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
820 report these files to the DragonFly developers so that they can be added to
821 the 'upgrade' target.
822